BuildRequires: velocity14
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_gcj_support 0
%define gcj_support 0
%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define namedversion 1.0

Name:           maven-doxia
Version:        1.0
Release:        alt8_2jpp6
Epoch:          0
Summary:        Content generation framework
License:        Apache Software License
Group:          Development/Java
URL:            http://maven.apache.org/doxia/

# svn export http://svn.apache.org/repos/asf/maven/doxia/doxia/tags/doxia-1.0
#       maven-doxia/
# tar czf maven-doxia-1.0-src.tar.gz maven-doxia/
Source0:        %{name}-%{version}-src.tar.gz

Source1:        %{name}-decoration-model-build.xml
Source2:        %{name}-core-build.xml
Source3:        %{name}-sink-api-build.xml
Source4:        %{name}-site-renderer-build.xml

# These files are taken from the doxia build itself, done with maven2
# To regenerate, build above tarball with upstream maven
Source5:        %{name}-autogenerated-files.tar.gz

Source6:        %{name}-jpp-depmap.xml
Source7:        %{name}-settings.xml

Patch0:         maven-doxia-1.0-pom.patch
Patch1:         maven-doxia-module-apt-pom.patch
Patch2:         maven-doxia-module-xdoc-pom.patch


%if ! %{gcj_support}
BuildArch:      noarch
%else
ExcludeArch:   ppc64
%endif

BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: ant >= 0:1.7.1
BuildRequires: ant-nodeps
%if %{with_maven}
BuildRequires: maven2 >= 0:2.0.8
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-site
BuildRequires: maven2-plugin-assembly
BuildRequires: maven-plugin-tools
BuildRequires: maven-surefire-maven-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: plexus-maven-plugin
BuildRequires: qdox161
BuildRequires: modello-maven-plugin
BuildRequires: plexus-xmlrpc >= 0:1.0-0.b4.3
BuildRequires: plexus-cdc
BuildRequires: excalibur-avalon-framework
BuildRequires: apache-commons-parent
%endif
BuildRequires: classworlds
BuildRequires: apache-commons-collections
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-validator
BuildRequires: junit
BuildRequires: oro
BuildRequires: plexus-container-default
BuildRequires: plexus-cli
BuildRequires: plexus-i18n
BuildRequires: plexus-utils
BuildRequires: plexus-velocity
BuildRequires: velocity
BuildRequires: itext <= 2.0
BuildRequires: xml-commons-jaxp-1.3-apis

Requires: classworlds
Requires: apache-commons-collections
Requires: jakarta-commons-logging
Requires: jakarta-commons-validator
Requires: junit
Requires: oro
Requires: plexus-container-default
Requires: plexus-i18n
Requires: plexus-utils
Requires: plexus-velocity
Requires: velocity

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
Source44: import.info
Patch33: maven-doxia-1.0-alt-remove-tagletartifact.patch

%description
Doxia is a content generation framework which aims to provide its
users with powerful techniques for generating static and dynamic
content. Doxia can be used to generate static sites in addition to
being incorporated into dynamic content generation systems like blogs,
wikis and content management systems.

%if %{with_maven}
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description javadoc
Javadoc for %{name}.
%endif

%prep
%setup -q -n %{name}

%if %{without_maven}
# Extract autogenerated (by maven) files
tar xzf %{SOURCE5}
rm -rf doxia-decoration-model
rm -rf doxia-site-renderer

cp -p %{SOURCE2} doxia-core/build.xml
cp -p %{SOURCE3} doxia-sink-api/build.xml
%endif

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

cp %{SOURCE7} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
%patch33 -p0

%build

%if %{with_maven}

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/poms/

export M2_SETTINGS=$(pwd)/settings.xml

mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
        -e \
        -s ${M2_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE6} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 

mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
        -e \
        -s ${M2_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE6} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%else

mkdir lib
build-jar-repository -s -p lib/ \
                        commons-collections \
                        commons-logging-api \
                        classworlds \
                        junit \
                        oro \
                        plexus/container-default \
                        plexus/i18n \
                        plexus/utils \
                        plexus/velocity \
                        velocity

for project in doxia-decoration-model \
           doxia-sink-api \
           doxia-core \
           doxia-site-renderer; do

       pushd $project

ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5  -Dmaven.mode.offline=true -Dmaven.repo.local=$MAVEN_REPO_LOCAL

           # Copy over the jar
           cp -p target/*jar ../lib/$project.jar
       popd
done

%endif

%install

# jars/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

for targetdir in `find -type d -name target`; do

    targetdir=`echo $targetdir | sed -e s:^\./::g`

    modulename=`echo $targetdir | awk -F / '{print $(NF-1)}'`
    strippedmodulename=`echo $modulename | sed -e s:^doxia-::g`

    # Does the module have a jar?
    if [ -f $targetdir/$modulename-%{namedversion}.jar ]; then
        cp -p $targetdir/$modulename-%{namedversion}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/$strippedmodulename-%{namedversion}.jar
    fi


    # Skip parent pom
    if [ ! -z $strippedmodulename ]; then
        cp -p $targetdir/../pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-$strippedmodulename.pom

        %add_to_maven_depmap org.apache.maven.doxia $modulename %{namedversion} JPP/maven-doxia $strippedmodulename
    fi
    
done

# Install parent pom
install -pm 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-doxia-doxia.pom
%add_to_maven_depmap org.apache.maven.doxia doxia %{namedversion} JPP/maven-doxia doxia


(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{namedversion}*; \
  do ln -sf ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

# Install javadocs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%{_libdir}/gcj/%{name}
%endif

%if %{with_maven}
%files javadoc
%doc %{_javadocdir}/*
%endif

%changelog
* Wed Feb 23 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt8_2jpp6
- fixed build with new maven-2.0.8-29+plugin-tools
  (removed plexus-javadoc references)

* Tue Feb 22 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt7_2jpp6
- fixed build

* Sat Jan 29 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt6_2jpp6
- release; temporarily added maven2-plugin-plugin to BR:.

* Mon Sep 20 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt6_0.3.a10.8jpp6
- build for new maven2 version

* Fri Sep 17 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt5_0.a10.4jpp5
- added version to Provides: maven-doxia-sitetools for jpp6 compatibility

* Mon Sep 13 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt4_0.a10.4jpp5
- added Provides: maven-doxia-sitetools for jpp6 compatibility

* Wed May 12 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt3_0.a10.4jpp5
- fixes for java6 support

* Sat Mar 14 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt2_0.a10.4jpp5
- maven 2.0.7 build

* Fri Jan 30 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1.1jpp
maven 2.0.7 bootstrap

